// Equivalent of jquery document.ready
function docReady(fn) {
    if (document.readyState === "complete" || document.readyState === "interactive") {
        setTimeout(fn, 1);
    } else {
        document.addEventListener("DOMContentLoaded", fn);
    }
}

// DOM is loaded and ready for manipulation here
docReady(function() {
    var date = new Date();
    var width = screen.width;
    var height = screen.height;

    jQuery.ajax({
        type: "POST",
        url: "../wp-content/plugins/woocommerce-api/browser.php",
        data: {
            browserJavaEnabled: navigator.javaEnabled(),
            browserLanguage: navigator.language,
            browserColorDepth: screen.colorDepth,
            browserScreenHeight: height,
            browserScreenWidth: width,
            browserTZ: date.getTimezoneOffset(),
            challengeWindowSize: challengeWindowSize(width)
        }
    });
});

function challengeWindowSize(width) {
    if (width <= 250) {
        return "01";
    } else if (width > 250 && width <= 390) {
        return "02";
    } else if (width > 390 && width <= 500) {
        return "03";
    } else if (width > 500 && width <= 600) {
        return "04";
    } else {
        return "05";
    }
}


var successCallback = function(data) {

    var checkout_form = jQuery( 'form.woocommerce-checkout' );

    // add a token to our hidden input field
    // console.log(data) to find the token
    checkout_form.find('#papam_token').val(data.token);

    // deactivate the tokenRequest function event
    if(checkout_form.off( 'checkout_place_order', tokenRequest )){}

    // submit the form now
    checkout_form.submit();

};

var errorCallback = function(data) {
    console.log(data);
};


var comNpay = {};


// To replace with the url of your website
var origin = papam_params['origin'];

// Generic settings
var apitoken = "/rest/token/create";
var urltoken = papam_params['apiurl'] + apitoken;


var cardType = "";


// Card check
comNpay.checkCard = function(){
    var card = jQuery("#papam_ccNo");
    card.addClass("input-text");
    var cardClass = card.closest('.form-row');
    if(!isValidCard(card.val())){
        card.removeClass("input-text");
        return false;
    }else{
        cardClass.addClass('woocommerce-validated');
        return true;
    }
};

// Date check
comNpay.checkDate = function(){
    var re = /^(0[1-9]{1}|10|11|12)[\/][0-9]{2}$/g;
    var re2 = /^(0[1-9]{1}|10|11|12)[0-9]{2}$/g;
    var date = jQuery("#papam_expdate");
    date.addClass("input-text");
    var dateClass = date.closest('.form-row');
    if(!re.test(date.val()) && !re2.test(date.val())){
        date.removeClass("input-text");
        return false;
    }else{
        if (date.val().search('/') == -1) {
            var addSlash = date.val().substr(0,2) + '/' + date.val().substr(2,2);
            date.val(addSlash);
        }
        dateClass.addClass('woocommerce-validated');
        return true;
    }
};

// Cvv check
comNpay.checkCvv = function(){
    var cvv = jQuery("#papam_cvv");
    cvv.addClass("input-text");
    var cvvClass = cvv.closest('.form-row');
    if(cvv.val().length > 4 || cvv.val().length < 3){
        cvv.removeClass("input-text");
        return false;
    }else{
        cvvClass.addClass('woocommerce-validated');
        return true;
    }
};

function isValidCard(identifier) {
    var sum     = 0,
        alt     = false,
        i       = identifier.length-1,
        num;
    if (identifier.length < 13 || identifier.length > 19){
        return false;
    }
    while (i >= 0){
        //get the next digit
        num = parseInt(identifier.charAt(i), 10);
        //if it's not a valid number, abort
        if (isNaN(num)){
            return false;
        }
        //if it's an alternate number...
        if (alt) {
            num *= 2;
            if (num > 9){
                num = (num % 10) + 1;
            }
        }
        //flip the alternate bit
        alt = !alt;
        //add to the rest of the sum
        sum += num;
        //go to next digit
        i--;
    }
    //determine if it's valid
    return (sum % 10 == 0);
}


var rvalue = false;

comNpay.checkAndcreateToken = function() {
    if(comNpay.checkCard() && comNpay.checkDate() && comNpay.checkCvv()) {
        var cardNumber = jQuery("#papam_ccNo").val();
        var cardExpirationDate = jQuery("#papam_expdate").val().replace(/ /g, '');
        var cvv = jQuery("#papam_cvv").val();

        jQuery.ajax({
            type: "POST",
            url: urltoken,
            data: {
                serialNumber: papam_params['publishableKey'],
                cardNumber: cardNumber.replace(/\s/g, ''),
                cardExpirationDate: cardExpirationDate,
                cvv: cvv,
                cardType: cardType,
                origin: origin
            },
            dataType: "json"
        }).done(function (msg) {
            if (msg['ok']) {
                jQuery.ajax({
                    type: "POST",
                    url: papam_params['tokenregurl'],
                    data: {
                        token: msg['token']['tokenRef']
                    },
                    dataType: "json"
                }).done(function () {
                    jQuery("#token").val(msg['token']['tokenRef']);
                    rvalue = true;
                });
                rvalue = false;
            } else {
                rvalue = true;
            }
        });
    }else{
        rvalue = true;
    }
};


jQuery(function($){
    var checkout_form = $( 'form.woocommerce-checkout' );
    checkout_form.on( 'checkout_place_order', function(){
        setTimeout(function(){ return rvalue; }, 3000);
    });

});

